Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12741)
@@ -1486,5 +1572,6 @@
         # InvalidTransitionError is catched
         self.assertTrue(
-            '<div class="alert alert-warning">Attached documents must be verified first.</div>'
+            '<div class="alert alert-warning">Attached documents '
+            'must be verified first.</div>'
             in self.browser.contents)
         self.browser.open(self.contracts_path + '/CON1/trigtrans')
@@ -1493,2 +1580,30 @@
         self.browser.getControl("Apply").click()
         self.assertEqual(IWorkflowState(self.contract).getState(), 'approved')
+
+    def test_select_payment(self):
+        # select payment
+        self.prepare_payment_select()
+        self.browser.open('%s/CON1/edit' % self.contracts_path)
+        self.browser.getControl("Proceed to checkout").click()
+        self.assertTrue(
+            "Select payment method" in self.browser.contents)
+        self.assertTrue(
+            'Credit Card (Demo Payments)' in self.browser.contents)
+
+    def test_select_payment_no_choice(self):
+        # we get warned if no payment was selected
+        self.prepare_payment_select()
+        self.browser.open(
+            '%s/CON1/select_payment_method' % self.contracts_path)
+        self.browser.getControl(self.never_ending_button_text).click()
+        self.assertTrue(
+            'Please pick a payment method' in self.browser.contents)
+
+    def test_select_payment_demo_provider(self):
+        # we can proceed with payments if we select a payment method
+        self.prepare_payment_select()
+        self.browser.open(
+            '%s/CON1/select_payment_method' % self.contracts_path)
+        radio_ctrl = self.browser.getControl(name='gw')
+        radio_ctrl.displayValue = ['Credit Card (Demo Payments)']
+        self.browser.getControl(self.never_ending_button_text).click()
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_contract.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_contract.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_contract.py	(revision 12741)
@@ -19,14 +19,24 @@
 Tests for contracts.
 """
+import decimal
 from zope.interface.verify import verifyClass, verifyObject
-from zope.component import createObject
+from zope.component import createObject, getUtility, getUtilitiesFor
+from zope.component.hooks import setSite
 from hurry.workflow.interfaces import (
     IWorkflowInfo, IWorkflowState, InvalidTransitionError)
 from waeup.ikoba.customers.interfaces import (
     IContractsContainer, IContract)
-from waeup.ikoba.interfaces import IObjectHistory
 from waeup.ikoba.customers.contracts import (
-    ContractsContainer, SampleContract)
+    ContractsContainer, SampleContract, ContractPayer, ContractFinder,
+    PayableContract,
+    )
+from waeup.ikoba.app import Company
+from waeup.ikoba.customers.customer import Customer
+from waeup.ikoba.payments.interfaces import (
+    IPaymentItem, IPayer, IPayableFinder, IPayable,
+    )
+from waeup.ikoba.products.productoptions import ProductOption
 from waeup.ikoba.testing import (FunctionalLayer, FunctionalTestCase)
+
 
 class ContractsContainerTestCase(FunctionalTestCase):
@@ -89,2 +99,133 @@
         self.assertTrue('Contract created by system' in messages)
         return
+
+
+class TestContractHelpers(FunctionalTestCase):
+
+    layer = FunctionalLayer
+
+    def test_payer_adapter(self):
+        # we can adapt IContract to IPayer (i.e. create a payer)
+        customer = Customer()
+        customer.firstname, customer.lastname = u'Anna', u'Tester'
+        contract = createObject(u'waeup.SampleContract')
+        customer['contracts'] = ContractsContainer()
+        customer['contracts'].addContract(contract)
+        result = IPayer(contract)
+        self.assertTrue(isinstance(result, ContractPayer))
+        verifyObject(IPayer, result)
+        self.assertEqual(result.first_name, u'Anna')
+        self.assertEqual(result.last_name, u'Tester')
+        self.assertEqual(result.payer_id, customer.customer_id)
+
+    def test_contract_finder_iface(self):
+        # we have a contract finder that returns IPayableFinder data.
+        verifyClass(IPayableFinder, ContractFinder)
+
+    def test_contract_finder_registered(self):
+        # the contract finder is a utility registered on startup
+        util = getUtility(IPayableFinder, name='contracts_finder')
+        self.assertTrue(isinstance(util, ContractFinder))
+        utils = [util for name, util in getUtilitiesFor(IPayableFinder)
+                 if isinstance(util, ContractFinder)]
+        self.assertEqual(len(utils), 1)
+
+    def create_contract_and_site(self):
+        contract = SampleContract()
+        option1 = ProductOption(u"Fee 1", decimal.Decimal("31.10"), "USD")
+        option2 = ProductOption(u"Fee 2", decimal.Decimal("12.12"), "USD")
+        contract.product_options = [option1, option2]
+        contract.contract_id = u'CON1234'
+        self.getRootFolder()['app'] = Company()
+        app = self.getRootFolder()['app']
+        setSite(app)
+        return contract, app
+
+    def test_contract_finder(self):
+        # the contract finder can really find contracts
+        contract, app = self.create_contract_and_site()
+        app['mycontract'] = contract  # trigger cataloging
+        finder = ContractFinder()
+        result = finder.get_payable_by_id('CON1234')
+        self.assertTrue(result is contract)
+
+    def test_contract_finder_not_stored(self):
+        # we get none if an id is not stored
+        contract, app = self.create_contract_and_site()
+        app['mycontract'] = contract  # trigger cataloging
+        finder = ContractFinder()
+        result = finder.get_payable_by_id('Not-a-valid-id')
+        self.assertTrue(result is None)
+
+    def test_contract_finder_no_catalog(self):
+        # contract finder does not complain about missing catalog
+        finder = ContractFinder()
+        result = finder.get_payable_by_id('CON1234')
+        self.assertTrue(result is None)
+
+
+class TestContractAsPayable(FunctionalTestCase):
+
+    layer = FunctionalLayer
+
+    def test_adaptable(self):
+        # we can turn contracts into payables.
+        contract = SampleContract()
+        payable = IPayable(contract)
+        self.assertTrue(payable is not None)
+        self.assertTrue(isinstance(payable, PayableContract))
+
+    def test_payable_iface(self):
+        # PayableContracts really provide IPayable
+        contract = SampleContract()
+        option1 = ProductOption(u"Fee 1", decimal.Decimal("31.10"), "USD")
+        option2 = ProductOption(u"Fee 2", decimal.Decimal("12.12"), "USD")
+        contract.product_options = [option1, option2]
+        payable = PayableContract(contract)
+        verifyObject(IPayable, payable)
+        verifyClass(IPayable, PayableContract)
+
+    def test_payable_simple_attributes(self):
+        # the simple attribs are set correctly, according to context contract
+        contract = SampleContract()
+        contract.title = u'the title'
+        option1 = ProductOption(u"Fee 1", decimal.Decimal("31.10"), "EUR")
+        option2 = ProductOption(u"Fee 2", decimal.Decimal("12.12"), "EUR")
+        contract.product_options = [option1, option2]
+        payable = PayableContract(contract)
+        self.assertTrue(contract.contract_id, payable.payable_id)
+        self.assertEqual(payable.title, contract.title)
+        self.assertEqual(payable.currency, 'EUR')
+
+    def test_payable_items(self):
+        # we can get payment items from payable
+        contract = SampleContract()
+        option1 = ProductOption(u"Fee 1", decimal.Decimal("31.10"), "EUR")
+        option2 = ProductOption(u"Fee 2", decimal.Decimal("12.12"), "EUR")
+        contract.product_options = [option1, option2]
+        payable = PayableContract(contract)
+        items = payable.payment_items
+        self.assertTrue(isinstance(items, tuple))
+        self.assertEqual(len(items), 2)
+        verifyObject(IPaymentItem, items[0])
+        verifyObject(IPaymentItem, items[1])
+        self.assertEqual(items[0].item_id, '0')
+        self.assertEqual(items[0].title, u'Fee 1')
+        self.assertEqual(items[0].amount, decimal.Decimal("31.10"))
+
+    def test_payable_no_items(self):
+        # payables work also with no options set on contract
+        contract = SampleContract()
+        payable = PayableContract(contract)
+        items = payable.payment_items
+        self.assertTrue(isinstance(items, tuple))
+        self.assertEqual(len(items), 0)
+        self.assertEqual(payable.currency, None)
+
+    def test_different_currencies_forbiddedn(self):
+        # we do not accept different currencies in payment items
+        contract = SampleContract()
+        option1 = ProductOption(u"Fee 1", decimal.Decimal("31.10"), "EUR")
+        option2 = ProductOption(u"Fee 2", decimal.Decimal("12.12"), "USD")
+        contract.product_options = [option1, option2]
+        self.assertRaises(ValueError, PayableContract, contract)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_customer.py	(revision 12741)
@@ -21,20 +21,21 @@
 import re
 import unittest
-import grok
 from cStringIO import StringIO
-from datetime import tzinfo
-from zope.component import getUtility, queryUtility, createObject
-from zope.catalog.interfaces import ICatalog
+from zope.component import getUtility, getUtilitiesFor
+from zope.component.hooks import setSite
 from zope.component.interfaces import IFactory
-from zope.event import notify
 from zope.interface import verify
-from zope.schema.interfaces import RequiredMissing
 from waeup.ikoba.interfaces import IExtFileStore, IFileStoreNameChooser
+from waeup.ikoba.app import Company
 from waeup.ikoba.customers.customer import (
-    Customer, CustomerFactory, handle_customer_removed, path_from_custid)
+    Customer, CustomerFactory, handle_customer_removed, path_from_custid,
+    CustomerPayer, CustomerFinder,
+    )
 from waeup.ikoba.customers.interfaces import (
     ICustomer, ICustomerNavigation, ICustomersUtils)
 from waeup.ikoba.customers.tests.test_batching import CustomerImportExportSetup
+from waeup.ikoba.payments.interfaces import IPayer, IPayerFinder
 from waeup.ikoba.testing import FunctionalLayer, FunctionalTestCase
+
 
 class HelperTests(unittest.TestCase):
@@ -59,4 +60,5 @@
             path_from_custid('KM123456'), u'00120/KM123456')
         return
+
 
 class CustomerTest(FunctionalTestCase):
@@ -92,4 +94,62 @@
 
 
+class TestCustomerHelpers(FunctionalTestCase):
+
+    layer = FunctionalLayer
+
+    def test_payer_adapter(self):
+        # we can adapt ICustomer to IPayer (i.e. create a payer)
+        customer = Customer()
+        customer.firstname, customer.lastname = u'Anna', u'Tester'
+        result = IPayer(customer)
+        self.assertTrue(isinstance(result, CustomerPayer))
+        verify.verifyObject(IPayer, result)
+        self.assertEqual(result.first_name, u'Anna')
+        self.assertEqual(result.last_name, u'Tester')
+        self.assertEqual(result.payer_id, customer.customer_id)
+
+    def test_customer_finder_iface(self):
+        # we have a customer finder that returns IPayableFinder data.
+        verify.verifyClass(IPayerFinder, CustomerFinder)
+
+    def test_customer_finder_registered(self):
+        # the customer finder is a utility registered on startup
+        util = getUtility(IPayerFinder, name='customer_finder')
+        self.assertTrue(isinstance(util, CustomerFinder))
+        utils = [util for name, util in getUtilitiesFor(IPayerFinder)
+                 if isinstance(util, CustomerFinder)]
+        self.assertEqual(len(utils), 1)
+
+    def create_customer_and_site(self):
+        customer = Customer()
+        customer.customer_id = u'CUST1'
+        self.getRootFolder()['app'] = Company()
+        app = self.getRootFolder()['app']
+        setSite(app)
+        return customer, app
+
+    def test_customer_finder(self):
+        # the customer finder can really find customers
+        customer, app = self.create_customer_and_site()
+        app['mycustomer'] = customer  # trigger cataloging
+        finder = CustomerFinder()
+        result = finder.get_payer_by_id('CUST1')
+        self.assertTrue(result is customer)
+
+    def test_customer_finder_not_stored(self):
+        # we get none if an id is not stored
+        customer, app = self.create_customer_and_site()
+        app['mycustomer'] = customer  # trigger cataloging
+        finder = CustomerFinder()
+        result = finder.get_payer_by_id('Not-a-valid-id')
+        self.assertTrue(result is None)
+
+    def test_customer_finder_no_catalog(self):
+        # customer finder does not complain about missing catalog
+        finder = CustomerFinder()
+        result = finder.get_payer_by_id('CUST1')
+        self.assertTrue(result is None)
+
+
 class CustomerRemovalTests(CustomerImportExportSetup):
     # Test handle_customer_removed
@@ -192,4 +252,5 @@
         return
 
+
 class CustomerFactoryTest(FunctionalTestCase):
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/demo_provider.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/demo_provider.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/demo_provider.py	(revision 12741)
@@ -1,9 +1,32 @@
+import datetime
 import grok
+import random
+import re
+from zope.event import notify
 from waeup.ikoba.interfaces import MessageFactory as _
-from waeup.ikoba.payments.interfaces import IPaymentGatewayService
-from waeup.ikoba.payments.payment import Payment
+from waeup.ikoba.browser.layout import IkobaEditFormPage, action
+from waeup.ikoba.payments.interfaces import (
+    IPaymentGatewayService, IPayment, IPayable, IPayer, IPayee,
+    STATE_AWAITING_GATEWAY_CONFIRM, STATE_PAID)
+from waeup.ikoba.payments.payment import (
+    Payment, get_payment, find_payable_from_payable_id, format_amount,
+    find_payer_from_payer_id, PaymentProviderServiceBase,
+    PaymentWaitingForGatewayEvent, PaymentFinishedEvent)
 
 
-class DemoCreditcardPaymentService(grok.GlobalUtility):
+grok.templatedir('templates')
+
+
+WARN_FINAL_SUBMIT = _(
+    'You can not edit your contract after final submission. '
+    'Do you really want to submit?'
+)
+
+
+RE_CC_NUMBER = re.compile('^[0-9]{9,25}$')
+RE_CSC = re.compile('^[0-9]{3,4}$')
+
+
+class DemoCreditcardPaymentService(PaymentProviderServiceBase):
     """A demo payment gateway service.
 
@@ -13,13 +36,141 @@
     grok.name('demo_creditcard')
 
-    title = _(u'Demo Creditcard')
+    title = _(u'Credit Card (Demo Payments)')
 
-    def create_payment(self, payer, payment_item_list=[],  payee=None):
+    def create_payment(self, payer, payable,  payee=None):
         """Create a payment.
         """
-        payment = Payment()
+        if not IPayer.providedBy(payer):
+            payer = IPayer(payer)
+        if not IPayable.providedBy(payable):
+            payable = IPayable(payable)
+        if (payee is not None) and (not IPayee.providedBy(payee)):
+            payee = IPayee(payee)
+        payment = Payment(payer, payable, payee)
         payment.gateway_service = 'demo_creditcard'  # must be grok.name above
-        payment.payer_id = payer.payer_id
-        for item in payment_item_list:
-            payment.add_payment_item(item)
         return payment
+
+    def next_step(self, payment_id):
+        """Tell where to go next.
+
+        Returns (context, view_name). Both may be none.
+        """
+        payment = get_payment(payment_id)
+        if payment is None:
+            return None, None
+        if payment.state == STATE_AWAITING_GATEWAY_CONFIRM:
+            return payment, 'demo_cc2'
+        return payment, 'demo_cc1'
+
+
+class CreditCardStep1(IkobaEditFormPage):
+    grok.context(IPayment)
+    grok.name('demo_cc1')
+    # XXX: Use own permissions for payments
+    grok.require('waeup.Authenticated')
+    label = "Enter Credit Card Details"
+    grok.template('demo_cc_step1')
+    pnav = 4
+
+    def validate_form(self):
+        fields = ['first_name', 'last_name', 'cc_number', 'csc', 'exp_date']
+        cls = 'form-group'
+        if len(self.request.form):
+            cls += ' has-success'
+        result = dict([(x, cls) for x in fields])
+        if not len(self.request.form):
+            return True, result
+        err = 'form-group has-error'
+        if not self.first_name:
+            result['first_name'] = err
+        if not self.last_name:
+            result['last_name'] = err
+        if not RE_CC_NUMBER.match(self.cc_number):
+            result['cc_number'] = err
+        if not RE_CSC.match(self.csc):
+            result['csc'] = err
+        if err in result.values():
+            return False, result
+        return True, result
+
+    def update(self, first_name=None, last_name=None, cc_number=None,
+               month=None, year=None):
+        self.payer = IPayer(find_payer_from_payer_id(self.context.payer_id))
+        self.payable = IPayable(find_payable_from_payable_id(
+            self.context.payable_id))
+        form = self.request.form
+        self.first_name = form.get('first_name', self.payer.first_name)
+        self.last_name = form.get('last_name', self.payer.last_name)
+        self.cc_number = form.get('cc_number', '')
+        self.month = int(form.get('exp_month', datetime.datetime.now().month))
+        self.year = int(form.get('exp_year', datetime.datetime.now().year))
+        self.csc = form.get('csc', '')
+        self.amount = format_amount(
+            self.context.amount, self.context.currency)
+        self.months = ''.join([
+            '<option%s>%s</option>' % (
+                (x == self.month) and ' selected="selected"' or '',
+                x) for x in range(1, 13)])
+        self.years = ''.join([
+            '<option%s>%s</option>' % (
+                (x == self.year + 1) and ' selected="selected"' or '',
+                x) for x in range(self.year - 1, self.year + 15)])
+        self.ok, self.validations = self.validate_form()
+
+    @action(_('Authorize Payment'), warning=WARN_FINAL_SUBMIT,
+            style="primary")
+    def authorize(self, **data):
+        if not self.ok:
+            self.flash(_("Please review (red) entries below!"),
+                       type='warning')
+            return
+        # XXX: payment really started, do lots of logging
+        self.context.state = STATE_AWAITING_GATEWAY_CONFIRM
+        notify(PaymentWaitingForGatewayEvent(self.context))
+        self.redirect(self.url(self.context, 'demo_cc2'))
+        return
+
+    @action(_('Cancel'))
+    def cancel(self, **data):
+        """Go back to the payable (if possible) or site home.
+        """
+        payable_id = getattr(self.context, 'payable_id', '')
+        payed_item = find_payable_from_payable_id(payable_id)
+        self.flash(_("Payment cancelled."))
+        if payed_item is not None:
+            # remove context/payment?
+            target = payed_item
+        else:
+            target = grok.getSite()
+        self.redirect(self.url(target))
+
+
+class CreditCardStep2(IkobaEditFormPage):
+    grok.context(IPayment)
+    grok.name('demo_cc2')
+    # XXX: Use own permissions for payments
+    grok.require('waeup.Authenticated')
+    label = "&nbsp;"
+    grok.template('demo_cc_step2')
+    pnav = 4
+
+    def update(self):
+        cnt = int(self.request.form.get('cnt', '0'))
+        self.cnt = cnt + 1
+        threshold = random.choice(range(10))
+        self.success = False
+        # HERE WOULD WE REALLY ASK FOR VERIFICATION
+        if threshold <= cnt:
+            self.success = True
+            self.flash(_("Your payment was finished successfully."))
+        if self.request.form.get('SUBMIT', None):
+            self.renew()
+
+    def renew(self):
+        if not self.success:
+            return
+        payable_id = getattr(self.context, 'payable_id', '')
+        payed_item = find_payable_from_payable_id(payable_id)
+        self.context.state = STATE_PAID
+        notify(PaymentFinishedEvent(self.context))
+        self.redirect(self.url(payed_item))
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/payments/interfaces.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/payments/interfaces.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/payments/interfaces.py	(revision 12741)
@@ -20,6 +20,5 @@
 from zope import schema
 from zope.component import getUtilitiesFor
-from zope.container.interfaces import IContainer
-from zope.container.constraints import contains
+from zope.component.interfaces import IObjectEvent
 from zope.interface import Interface, Attribute
 from waeup.ikoba.interfaces import (
@@ -30,9 +29,13 @@
 #: Possible states of payments
 STATE_UNPAID = 1
-STATE_PAID = 2
-STATE_FAILED = 4
+STATE_AWAITING_USER_CONFIRM = 2
+STATE_AWAITING_GATEWAY_CONFIRM = 4
+STATE_PAID = 64
+STATE_FAILED = 128
 
 payment_states = SimpleIkobaVocabulary(
     (_('Not yet paid'), STATE_UNPAID),
+    (_('Waiting for user confirm'), STATE_AWAITING_USER_CONFIRM),
+    (_('Waiting for verification'), STATE_AWAITING_GATEWAY_CONFIRM),
     (_('Paid'), STATE_PAID),
     (_('Failed'), STATE_FAILED),
@@ -40,4 +43,22 @@
 
 
+class IPaymentWaitingForGatewayEvent(IObjectEvent):
+    """Fired when a payment starts waiting for verification.
+    """
+    object = Attribute("""The payment waiting.""")
+
+
+class IPaymentFinishedEvent(IObjectEvent):
+    """Fired when a payment failed or succeeded.
+    """
+    object = Attribute("""The payment finished.""")
+
+
+class IPaymentAborted(IObjectEvent):
+    """Fired when a payment was aborted before external transactions.
+    """
+    object = Attribute("""The payment aborted.""")
+
+
 class PaymentGatewayServicesSource(BasicSourceFactory):
     """A source that lists available payment services.
@@ -88,9 +109,9 @@
         )
 
-    def create_payment(payer, payment_item_list,  payee):
+    def create_payment(payer, payable, payee):
         """Create a payment.
 
         For all parameters we expect an object, that implements
-        `IPayer`, `IPaymentItem`, or `IPayee` respectively. If not,
+        `IPayer`, `IPayable`, or `IPayee` respectively. If not,
         then the given objects must be at least adaptable to the
         respective interface.
@@ -102,4 +123,14 @@
         """
 
+    def next_step(payment_id):
+        """Returns a payment (as context) and a view name.
+
+        May result in (None, None).
+        """
+
+    def store(payment):
+        """Store `payment` in site.
+        """
+
 
 class IPaymentGatewayServicesLister(Interface):
@@ -136,4 +167,41 @@
         required=True,
         )
+
+
+class IPayableFinder(Interface):
+    """Finds payables.
+
+    For each type of content you want to make payable, you should
+    define an IPayableFinder that can lookup payables in the
+    site.
+
+    This enables access from payments (which store payable ids only)
+    to arbitrary content objects (for which a payable finder is
+    registered under some name).
+
+    The other way round (getting an id and other relevant data from
+    any content object) is ensured by IPayable adapters.
+    """
+    def get_payable_by_id(item_id):
+        """Get an item by its Id, or none.
+        """
+
+
+class IPayerFinder(Interface):
+    """Finds payers.
+
+    For each type of content you understand as payer, you should
+    define an IPayrtFinder that can lookup payers in the site.
+
+    This enables access from payments (which store payer ids only)
+    to arbitrary content objects (for which a payer finder is
+    registered under some name.
+
+    The other way round (getting an id and other relevant data from
+    any content object) is ensured by IPayer adapters.
+    """
+    def get_payer_by_id(item_id):
+        """Get a payer by its Id, or none.
+        """
 
 
@@ -161,5 +229,51 @@
 
 
-class IPayment(IContainer):
+class IPayable(Interface):
+    """Something that can be payed.
+
+    Designed to serve as adapter. IPayables turn arbitrary content
+    objects into something with a standarized interfaces for use with
+    payments.
+
+    While currency is important to tell about the amount currency, the
+    total amount is computed on-demand from payment items.
+    """
+    payable_id = schema.TextLine(
+        title=u'ID of a payable',
+        description=(u'It should be possible to lookup the payable id '
+                     u'by some registered IPayableFinder later on'),
+        required=True,
+        readonly=True,
+        )
+
+    title = schema.TextLine(
+        title=u'Title',
+        description=u'A short description of the payed item.',
+        required=True,
+        default=u'',
+        readonly=True,
+        )
+
+    currency = schema.Choice(
+        title=u'Currency',
+        source=ISO_4217_CURRENCIES_VOCAB,
+        required=True,
+        default='USD',
+        readonly=True,
+        )
+
+    payment_items = schema.Tuple(
+        title=u'Tuple of IPaymentItems.',
+        value_type=schema.Object(
+            title=u'Payment Item',
+            schema=IPaymentItem,
+            ),
+        required=False,
+        default=(),
+        readonly=True,
+        )
+
+
+class IPayment(IIkobaObject):
     """A base representation of payments.
 
@@ -185,9 +299,13 @@
     we mark the payment 'failed'.
     """
-    contains(IPaymentItem)
-
     payment_id = schema.TextLine(
         title=u'Payment Identifier',
         default=None,
+        required=True,
+        )
+
+    title = schema.TextLine(
+        title=u'Payment description.',
+        default=u'',
         required=True,
         )
@@ -203,5 +321,11 @@
         default=None,
         required=False,
-    )
+        )
+
+    payable_id = schema.TextLine(
+        title=u'ID of item/good being paid',
+        default=None,
+        required=False,
+        )
 
     gateway_service = schema.Choice(
@@ -256,10 +380,4 @@
         """
 
-    def add_payment_item(item):
-        """Payments contain payment items.
-
-        Add one
-        """
-
 
 class IPayer(Interface):
